
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Robert Izzard's compact bibliography, for use with
% bibtex and natbib.
%
% 1) Install `robcompact2023.bst` in one of your LaTeX directories, e.g. `$HOME/.latex`.
% 2) use `robcompact2023` as your bibliography style file.
% 3) insert the contents of `preamble.tex` (this file) in your document's preamble.
%
% This file is distributed under the LaTeX licence and
% is based on natbib's original code.
% https://www.latex-project.org/lppl/
%
% This is file `preamble.tex`
%
% Copyright 2023 Robert Izzard
%
% https://gitlab.com/rob.izzard/compact-bibtex-bibliography
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% fix left indent
\renewcommand\NAT@bibsetup%
   [1]{\setlength{\leftmargin}{0pt}\setlength{\itemindent}{-\leftmargin}%
       \setlength{\itemsep}{\bibsep}\setlength{\parsep}{\z@}}

% compact bibliography with natbib
\renewenvironment{thebibliography}[1]{%
 \bibsection\parindent \z@\bibpreamble\bibfont\begin{list}%
   {\@biblabel{\arabic{NAT@ctr}}}%
   {\@bibsetup{#1}%
    \setcounter{NAT@ctr}{0}}%
    \ifNAT@openbib%
      \renewcommand\newblock{}% was {par}
    \else%
      \renewcommand\newblock{\hskip .11em \@plus.33em \@minus.07em}%
    \fi%
    \sloppy\clubpenalty4000\widowpenalty4000%
    \sfcode`\.=1000\relax%  
    \let\citeN\cite \let\shortcite\cite
    \let\citeasnoun\cite
 }{\def\@noitemerr{%
  \PackageWarning{natbib}
     {Empty `thebibliography' environment}}%
  \end{list}
  \vskip-\lastskip}

% replace bibitem
\renewcommand\bibitem{%
  \@ifnextchar[{\@lbibitem}{%
    \global\NAT@stdbsttrue%
    \stepcounter{NAT@ctr}\@lbibitem[\arabic{NAT@ctr}]}}%
\def\@lbibitem[#1]#2{~$\bullet$~% bullet point goes here!
  \if\relax\@extra@b@citeb\relax\else%
    \@ifundefined{br@#2\@extra@b@citeb}{}{%
     \@namedef{br@#2}{\@nameuse{br@#2\@extra@b@citeb}}}\fi%
   \@ifundefined{b@#2\@extra@b@citeb}{\def\NAT@num{}}{\NAT@parse{#2}}%
    \NAT@ifcmd#1(@)(@)\@nil{#2}}%
\ifx\SK@lbibitem\@undefined\else%
   \let\SK@lbibitem\@lbibitem%
   \def\@lbibitem[#1]#2{%
     \SK@lbibitem[#1]{#2}\SK@\SK@@label{#2}\ignorespaces}\fi%
\newif\ifNAT@stdbst \NAT@stdbstfalse
